package ar.com.unobtainium.tonetennis.elements 
{
	import com.greensock.TweenMax;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author Balthazar Auger
	 */
	public class Ball extends Sprite 
	{
		
		private var _radius:int = 40;
		private var _fillColor:uint = 0xFFFFFF;
		
		public var direction:String = '';
		
		public const MAX_SPEED:int = 1200;
		public const SPEED_UNIT:int = 200;
		
		/**
		 * ball speed = milliseconds to cover the game field from one side to the other. Smaller is faster.
		 */
		public var speed:int;
		
		/**
		 * ball motion: reference to the current animation applied to this ball
		 */
		public var motion:TweenMax;
		
		public function Ball() 
		{
			super();
			
			this.speed = MAX_SPEED;
			
			this.draw();
			
		}
		
		private function draw():void
		{
			//draw it
			
			this.graphics.clear();
			this.graphics.beginFill(this._fillColor);
			this.graphics.drawRect(-(_radius/2), -(_radius/2), _radius, _radius);
			this.graphics.endFill();
		}
		
		public function boostBump():void
		{
			TweenMax.to(this, 0.25, {width: _radius*3, height: _radius*1.3, repeat:1, yoyo:true } );
		}
	}

}