package ar.com.unobtainium.tonetennis.elements 
{
	/**
	 * Stateful Data class that holds information on a player
	 * @author Balthazar Auger
	 */
	public class Player 
	{
		public var playerNum:int;
		public var opponent:Player;
		public var score:ScoreDisplay;
		
		/**
		 * Can be one of :
			 * kickoff : the player has a captured ball and needs to put it into play
			 * attack : the player who last touched the ball is attacking
			 * defense : the defending player can either volley the ball (home pad) back or try to catch it (reach pad)
			 * catching : the defending player has begun attempting to catch the ball (reach was pressed and hit ball).
			 * none
		 */
		public var state:String;
		
		public static const STATE_NONE:String = 'none';
		public static const STATE_SERVE:String = 'serve';
		public static const STATE_ATTACK:String = 'attack';
		public static const STATE_DEFENSE:String = 'defense';
		public static const STATE_CATCHING:String = 'catching';
		
		public function Player(num:int) 
		{
			this.playerNum = num;
			this.state = STATE_NONE;
			this.opponent = null;
		}
		
	}

}